/*
 * spec.maillage : maillage de l'objet (type Maillage)
 * spec.texture : Texturet
 * spec.ondraw : fonction lancée au dessin
 * spec.textureCouleur : filtre coloré
 */
var Objet=(function() {
    return {
        instance: function(spec) {            
            var texture=(spec.texture)?spec.texture:false,
                textureCouleur=(spec.textureCouleur)?spec.textureCouleur:false,
                ondraw=(spec.ondraw)?spec.ondraw: false;

            var that={
                draw: function() {
                    if (ondraw) spec.ondraw(that);
                    if (texture) texture.draw(0);
                    if (textureCouleur) textureCouleur.draw(1);
                    spec.maillage.draw();
                },

                drawPhysics: false,

                set_physics: function(phyFunc) {
                    that.drawPhysics=phyFunc;
                },

                set_textureCouleur: function(tc) {
                    textureCouleur=tc;
                }
            };
            return that;
        }
    }
})();

