/*
 * spec: empty
 */
var SHADERS;
var Shaders=(function (){

    var get_shader=function(source, type) {
            var shader = GL.createShader(type);
            GL.shaderSource(shader, source);
            GL.compileShader(shader);
            if (!GL.getShaderParameter(shader, GL.COMPILE_STATUS)) {
                alert(GL.getShaderInfoLog(shader));
                return false;
            }
            return shader;
    };

    var shader_vertex_source="$SHADER_VERTEX$",
        shader_fragment_source="$SHADER_FRAGMENT$";

    var shader_vertex,
        shader_fragment,
        shader_program;

    var position,
        sampler,
        samplerCouleur,
        LH;

    var that={
        instance: function(spec) {
            shader_vertex=get_shader(shader_vertex_source, GL.VERTEX_SHADER);
            shader_fragment=get_shader(shader_fragment_source, GL.FRAGMENT_SHADER);
            shader_program=GL.createProgram();
            GL.attachShader(shader_program, shader_vertex);
            GL.attachShader(shader_program, shader_fragment);
            GL.linkProgram(shader_program);            

            LH=GL.getUniformLocation(shader_program, "LH");
            sampler = GL.getUniformLocation(shader_program, "sampler");
            samplerCouleur = GL.getUniformLocation(shader_program, "samplerCouleur");

            position = GL.getAttribLocation(shader_program, "position");
            GL.enableVertexAttribArray(position);

            GL.useProgram(shader_program);
            this.set_samplers();
        },

        set_LH: function(l,h) {
            GL.uniform2f(LH,l,h);
        },
        
        set_samplers: function() {
            GL.uniform1i(sampler, 0);
            GL.uniform1i(samplerCouleur, 1);
        },

        set_vertexPointers: function() {
            GL.vertexAttribPointer(position, 2, GL.FLOAT, false,8,0) ;
        }

    };
    SHADERS=that;
    return that;

})();


