/*
 * spec.url: texture url if image
 * spec.canvas : canvas id if canvas
 * spec.video : video id if video
 */
var Texture=(function () {
    return {
        instance: function(spec) {
           var loaded=false,
               texture=GL.createTexture(),
               image;

           if (spec.url) {
               var load=function() {
                    GL.pixelStorei(GL.UNPACK_FLIP_Y_WEBGL, true);
                    GL.bindTexture(GL.TEXTURE_2D, texture);
                    GL.texImage2D(GL.TEXTURE_2D, 0, GL.RGBA, GL.RGBA, GL.UNSIGNED_BYTE, image);                    
                    GL.texParameteri( GL.TEXTURE_2D, GL.TEXTURE_WRAP_S, GL.CLAMP_TO_EDGE );
                    GL.texParameteri( GL.TEXTURE_2D, GL.TEXTURE_WRAP_T, GL.CLAMP_TO_EDGE );
                    GL.texParameteri(GL.TEXTURE_2D, GL.TEXTURE_MAG_FILTER, GL.NEAREST);
                    GL.texParameteri(GL.TEXTURE_2D, GL.TEXTURE_MIN_FILTER, GL.NEAREST);
                    GL.bindTexture(GL.TEXTURE_2D, null);
                    loaded=true;
               }
               image=new Image();
               image.src=spec.url;
               image.onload=load;
           } else if (spec.canvas) {
               image=document.getElementById(spec.canvas);
           } else if (spec.video) {
               image=document.getElementById(spec.video);
           }

           if (spec.video) {
               load=function() {
                    GL.pixelStorei(GL.UNPACK_FLIP_Y_WEBGL, true);
                    GL.bindTexture(GL.TEXTURE_2D, texture);                    
                    GL.texParameteri(GL.TEXTURE_2D, GL.TEXTURE_MAG_FILTER, GL.LINEAR);
                    GL.texParameteri(GL.TEXTURE_2D, GL.TEXTURE_MIN_FILTER, GL.LINEAR);
                    GL.bindTexture(GL.TEXTURE_2D, null);
                    loaded=true;                    
               }
           }
           if (spec.canvas || spec.video) load();

           var canaux=[GL.TEXTURE0, GL.TEXTURE1];
           var started=false;
           var that={
                   is_loaded: function() { return loaded; },
                   draw: function(canal) {                       
                       if (!loaded) return false;                       
                       GL.activeTexture(canaux[canal]);                       
                       GL.bindTexture(GL.TEXTURE_2D, texture);
                       return true;
                   },

                   refresh: function() {
                       GL.bindTexture(GL.TEXTURE_2D, texture);
                       if (spec.video) {                           
                            if (!started && image.currentTime>0) {
                                CV.width=image.videoWidth;
                                CV.height=image.videoHeight;
                                SHADERS.set_LH(CV.width, CV.height);
                                started=true;
                            }
                            if (image.readyState!=4) return;
                            GL.texImage2D(GL.TEXTURE_2D, 0, GL.RGB,GL.RGB, GL.UNSIGNED_BYTE, image );
                            GL.texParameteri( GL.TEXTURE_2D, GL.TEXTURE_WRAP_S, GL.CLAMP_TO_EDGE );
                            GL.texParameteri( GL.TEXTURE_2D, GL.TEXTURE_WRAP_T, GL.CLAMP_TO_EDGE );
                       } else {
                            GL.texImage2D(GL.TEXTURE_2D, 0, GL.RGBA, GL.RGBA, GL.UNSIGNED_BYTE, image);
                       }
                       GL.bindTexture(GL.TEXTURE_2D, null);
                   }
            };
            return that;
        }
    };
})();



