<?php
    header('X-Frame-Options: GOFORIT');
?>

<!doctype html>
<html lang="en">

	<head>
		<meta charset="utf-8">

		<title>Filtre vidéo coloré</title>

		<meta name="description" content="A framework for easily creating beautiful presentations using HTML">
		<meta name="author" content="Hakim El Hattab">

		<meta name="apple-mobile-web-app-capable" content="yes" />
		<meta name="apple-mobile-web-app-status-bar-style" content="black-translucent" />

		<link rel="stylesheet" href="reveal/css/reveal.min.css">
		<link rel="stylesheet" href="reveal/css/theme/default.css" id="theme">

                <script type="text/javascript" src="jquery/jquery-1.8.3.js"></script>
		<!-- For syntax highlighting -->
		<link rel="stylesheet" href="reveal/lib/css/zenburn.css">

		<!-- If the query includes 'print-pdf', use the PDF print sheet -->
		<script>
			document.write( '<link rel="stylesheet" href="reveal/css/print/' + ( window.location.search.match( /print-pdf/gi ) ? 'pdf' : 'paper' ) + '.css" type="text/css" media="print">' );
		</script>

		<!--[if lt IE 9]>
		<script src="lib/js/html5shiv.js"></script>
		<![endif]-->
	</head>

	<body>

		<div class="reveal">

			<!-- Any section element inside of this container is displayed as a slide -->
			<div class="slides">

				<section>
					<h1>Filtre vidéo coloré</h1>									
				</section>

				<section>
					<h2>Xavier Bourry</h2>
					<ul>
                                            <li>Studio de dev SPACEGOO ( <a href="http://www.spacegoo.com" target="_blank">spacegoo.com</a> )

                                            <li>Cours en Ecole d'Ingé : <a href="http://www.spacegoo.com/cours" target="_blank">Programmation 3D avec webgl</a>

                                            <li>Auteur de <a href="http://www.editions-eni.fr/supports-de-formation/webgl-guide-de-developpement-d-applications-web-3d/.4dd6f25ed95cc95d1069faf08936ddb9.html#!WithAjaxContent" target="_blank">Webgl: guide de programmation d'applications web3D</a> (Editions ENI, publié le 09/01/2013)

                                            <li>Mail : xavier@spacegoo.com
                                        </ul>
				</section>

				<!-- Example of nested vertical slides -->
				<section>
                                    <h2>Filtre vidéo coloré</h2>
                                        <ul>
                                        <li class="fragment">Capturer le flux webcam avec GetUserMedia API,
                                        <li class="fragment">Le traiter en temps réel avec webgl : lui reproduire une liste d'éffets colorimétriques réalisés avec un logiciel de retouche d'image,
                                        <li class="fragment">Le sauvegarder au format webM avec Whammy.js
                                        </ul>
                                    
				</section>

				<section iframe="../index.php">					
				</section>

				<section>
					<h2>GetUserMedia API</h2>
                                        <ul>
                                        <li class="fragment">Capture l'image de la webcam et le son du micro dans un élément VIDEO d'HTML5
                                        <li class="fragment">Validé par le W3C : <a target="_blank" href="http://www.w3.org/TR/mediacapture-streams/">spécifications</a>
                                        <li class="fragment">Pilier de <a target="_blank" href="http://www.webrtc.org">WebRTC</a> (avec RTCPeerConnection et RTCDataChannel)
                                        <li class="fragment">Compatibilité : FF 17, Chrome 21, Opera 12. Source : <a href="http://caniuse.com/stream" target="_blank">caniuse.com</a>
                                        </ul>
				</section>

				<section>
                                    <h2>Cross compatibilité</h2>
                                    <pre><code>
navigator.getMedia = ( navigator.getUserMedia ||
navigator.webkitGetUserMedia ||
navigator.mozGetUserMedia ||
navigator.msGetUserMedia);

window.URL = window.URL || window.webkitURL;
                                    </code></pre>
				</section>

				<section>
                                    
<pre><code style="max-height: 560px">var get_mediaStream=function(video, func, funcError) {
    navigator.getMedia (
        { video: true, audio: false },

        // successCallback
        function(locMediaStream) {
          video.src = window.URL.createObjectURL(locMediaStream);
          var timerUserMedia=setInterval(function(){
              if(video.readyState==4){
                clearInterval(timerUserMedia);
                video.width=video.videoWidth,
                video.height=video.videoHeight;
                video.autoplay=true;
                func(video);
              }
          }, 100);
        },

        // errorCallback
        function(err) {
          funcError();
        }
    );
}</code></pre>
				</section>

				<section>
					<h2>Le Filtre coloré</h2>
                                        <ul>
                                            <li >Fonction F:(R, V, B) &rarr; (R', V', B')
                                            <li class="fragment">Doit marcher quelle que soit F
                                            <li class="fragment">Stockée sous la forme d'une image contenant toutes les couleurs = palette
                                            <li class="fragment">Idée : F<sub>1</sub>:(R, V, B) &rarr; (X,Y) et F<sub>2</sub>: (X,Y) &rarr; (R',V',B')
                                            <li class="fragment">La palette représente F<sub>2</sub>
                                        </ul>
				</section>



				<section style="width: 1000px;">
                                    <h3>La palette</h3>
                                    <img src="palette.png" width="400" style="float: left; margin-right: 20px;"/>
                                    <div style="float: left; width: 500px">
                                    <ul>
                                        <li>Image de 4096 x 4096 pixels
                                        <li class="fragment" >Générée avec un script canvas2D
                                        <li class="fragment" >X = R + 256 * &lfloor; B/16 &rfloor;<br/>
                                            Y = V + 256 * (B-16*&lfloor;B/16 &rfloor;);
                                        <li class="fragment" >S'inverse en :<br/>
                                            R = X - 256 * &lfloor; X/256 &rfloor;<br/>
                                            V = Y - 256 * &lfloor; Y/256 &rfloor;<br/>
                                            B = 16*&lfloor; X/256 &rfloor; + &lfloor; Y/256 &rfloor;
                                        
                                    </ul>
                                    </div>
				</section>

                                <section>                                    
                                    Application à la palette les effets colorimétriques :
                                    <img src="scCam.png" width="300px" style="vertical-align: middle"/> &rarr; <img src="scCamPsy.png" width="300px" style="vertical-align: middle"/>
                                    <img src="palette.png" width="300px"style="vertical-align: middle"/> &rarr; <img src="palettePsy.png" width="300px"style="vertical-align: middle"/>
                                </section>

                                <section>
                                    <h2>Reproduction des effets</h2>
                                    <ul>
                                        <li>Soit un pixel de couleur C=(R, V, B) sur la vidéo
                                        <li class="fragment">Coordonnées de C sur la palette :<br><small>
                                            X = R + 256 * &lfloor; B/16 &rfloor;<br/>
                                            Y = V + 256 * (B-16*&lfloor;B/16 &rfloor;)</small>
                                        <li class="fragment">Récupération de la couleur modifiée sur la palette modifiée :
                                            C'=(R', V', B')=palette(X,Y)
                                        <li class="fragment">On affiche le pixel avec la couleur C'
                                    </ul>
                                </section>

                                <section>
                                    <h2>Implémentation</h2>
                                    <ul>
                                        <li>Avec Canvas2D, <code>getImageData</code> et <code>putImageData</code>
                                            <div class="fragment">20 images/seconde * résolution de 800*600 &rarr; 10<sup>7</sup> pixels/seconde à traiter. Trop lent.</div>
                                        <li class="fragment">WebGL : traitement en parallèle sur carte graphique &rarr; good
                                    </ul>
                                </section>

                                <section>
                                    <h2>WebGL</h2>
                                    <ul>
                                        <li>Utilisé ici pour de la 2D
                                        <li class="fragment">La vidéo est importée sur une texture
                                        <li class="fragment">La texture est affichée sur un quad sur tout le viewPort
                                        <li class="fragment">La conversion colorimétrique est effectuée dans le shader de fragments (par pixels)
                                    </ul>
                                </section>
                                <section>
                                    <h2>Création du contexte GL</h2>

Dans le code HTML :
<pre><code>&lt;canvas id="mon_canvas" width="800" height="600"&gt;&lt;/canvas&gt;
</code></pre>
Après le chargement de la page :
<pre><code>
var canvas=document.getElementById("mon_canvas");
var GL =canvas.getContext("experimental-webgl",{antialias: true});
</code></pre>
                                </section>


                                <section>

                                    <h2>Vidéo to texture</h2>
Création :
<pre><code>var texture=GL.createTexture();
GL.bindTexture(GL.TEXTURE_2D, texture);
GL.texParameteri(GL.TEXTURE_2D, GL.TEXTURE_MAG_FILTER, GL.LINEAR);
GL.texParameteri(GL.TEXTURE_2D, GL.TEXTURE_MIN_FILTER, GL.LINEAR);
</code></pre>
Rafraîchissement :
<pre><code>GL.bindTexture(GL.TEXTURE_2D, texture);
GL.texImage2D(GL.TEXTURE_2D, 0, GL.RGB,GL.RGB, GL.UNSIGNED_BYTE, video );
GL.texParameteri( GL.TEXTURE_2D, GL.TEXTURE_WRAP_S, GL.CLAMP_TO_EDGE );
GL.texParameteri( GL.TEXTURE_2D, GL.TEXTURE_WRAP_T, GL.CLAMP_TO_EDGE );
</code></pre>


                                </section>
                                <section>


                      
<h3>Création de l'écran</h3>
<pre><code>var coins= GL.createBuffer ();
GL.bindBuffer(GL.ARRAY_BUFFER, coins);
GL.bufferData(GL.ARRAY_BUFFER, new Float32Array([-1, -1,
                                                  1, -1,
                                                  1,  1,
                                                 -1,  1]),
                                                 GL.STATIC_DRAW);
var indices= GL.createBuffer ();
GL.bindBuffer(GL.ELEMENT_ARRAY_BUFFER, indices);
GL.bufferData(GL.ELEMENT_ARRAY_BUFFER, new Uint16Array([1,0,2,3]),GL.STATIC_DRAW);
</code></pre>

<h3>Rendu</h3>
<pre><code>GL.bindBuffer(GL.ARRAY_BUFFER, coins) ;
GL.vertexAttribPointer(position, 2, GL.FLOAT, false,8,0) ;
GL.bindBuffer(GL.ELEMENT_ARRAY_BUFFER, indices);
GL.drawElements(GL.TRIANGLE_STRIP, 4, GL.UNSIGNED_SHORT, 0);
</code></pre>
                                </section>
                                <section>
<h2>La palette</h2>
Stockée en tant que texture.<br/>
Envoyée aux shaders en plus de la vidéo (multisampling)
<pre><code>
GL.activeTexture(0);
GL.bindTexture(GL.TEXTURE_2D, texturePalette);
GL.activeTexture(1);
GL.bindTexture(GL.TEXTURE_2D, textureVideo);
</code></pre>

                                </section>

                                <section>
                                    <h2>Le shader de vertex</h2>
                                    <ul>
                                        <li>Exécuté sur le GPU
                                        <li class="fragment">Nécessite d'être compilé (non abordé)
                                        <li class="fragment">Appelé une fois pour chaque coin
                                        <li class="fragment">Code :<br/>
<pre><code>attribute vec2 position;
void main(void) {
    gl_Position = vec4(position, 0.,1.);
}
</code></pre>
                                    </ul>
                                    
                                </section>

                                <section>
                                    <h2>Le shader de fragments</h2>

                                    Appelé pour chaque pixel. La position du pixel est interpolée en fonction de la position retournée par le shader de vertex, <code>gl_Position</code>.

<pre><code>uniform sampler2D sampler, samplerPalette;
uniform vec2 LH; //dimensions de la video en pixels

void main(void) {
    vec2 uv=vec2(gl_FragCoord)/LH;
    vec4 vidCol = texture2D(sampler, uv);

    float blueBlock=floor(videoCol.b*256.);
    float yBlue=floor(blueBlock/16.)/16.;
    float xBlue=floor((blueBlock-yBlue*256.)/16.)/16.;

    //coordonnées de texture sur la palette :
    vec2 XY=vec2(videoCol.r/16.+yBlue, 1.-vidCol.g/16.-xBlue);
    gl_FragColor=texture2D(samplerPalette, XY);
}
</code></pre>
                                </section>
                                <section>
                                    <h2>Enregistrement vidéo</h2>
                                    <ul>
                                        <li><a href="https://github.com/antimatter15/whammy" target="_blank">Whammy.js</a> : encodeur de vidéo WebM en javascript
                                        <li class="fragment">Enregistre une vidéo à partir d'un canvas (2D ou webgl)
                                        <li class="fragment">Nécessite un rendu à fréquence constante
                                    </ul>
                                </section>

                                <section>
                                    <h2>Whammy.js</h2>
                                    Initialisation :
                                    <pre><code>var CAPTURER = new Whammy.Video(16); </code></pre>
                                    Dessin de la scène :
<pre><code>GL.viewport(0.0, 0.0, CV.width, CV.height);
[...] Envoi des textures et rendu de l'écran
GL.flush();
CAPTURER.add(CV);
</code></pre>
Fin de l'enregistrement :
<pre><code>
var output = CAPTURER.compile();
var href=(window.webkitURL || window.URL).createObjectURL(output);
window.open(href);
</code></pre>
                                </section>

				

				<section>
					<h1>Questions ?</h1>
				</section>

			</div>

		</div>

		<script src="reveal/lib/js/head.min.js"></script>
		<script src="reveal/js/reveal.min.js"></script>

		<script>
                        var IFRAMES=[];
			// Full list of configuration options available here:
			// https://github.com/hakimel/reveal.js#configuration
			Reveal.initialize({
				controls: true,
				progress: true,
				history: true,
				center: true,

				theme: Reveal.getQueryHash().theme, // available themes are in /css/theme
				transition: Reveal.getQueryHash().transition || 'default', // default/cube/page/concave/zoom/linear/fade/none

				// Optional libraries used to extend on reveal.js
				dependencies: [
					{ src: 'reveal/lib/js/classList.js', condition: function() { return !document.body.classList; } },
					{ src: 'reveal/plugin/markdown/showdown.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
					{ src: 'reveal/plugin/markdown/markdown.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
					{ src: 'reveal/plugin/highlight/highlight.js', async: true, callback: function() { hljs.initHighlightingOnLoad(); } },
					{ src: 'reveal/plugin/zoom-js/zoom.js', async: true, condition: function() { return !!document.body.classList; } },
					{ src: 'reveal/plugin/notes/notes.js', async: true, condition: function() { return !!document.body.classList; } }
					// { src: 'plugin/remotes/remotes.js', async: true, condition: function() { return !!document.body.classList; } }
				]
			});
                        Reveal.addEventListener( 'slidechanged', function( event ) {
                            // event.previousSlide, event.currentSlide, event.indexh, event.indexv
                            IFRAMES.map(function(iframe, i){
                                iframe.detach();
                                IFRAMES.splice(i,1);
                            });
                            var slideAttr=event.currentSlide.attributes;
                            if (!slideAttr.iframe) return false;
                            var src=slideAttr.iframe.value;
                            if (!src) return false;
                            var jq_section=$(event.currentSlide);
                            console.log(src);
                            var jq_iframe=$("<iframe></iframe>").attr("src", src).attr("width", "100%").attr("height", "100%").appendTo(jq_section);
                            IFRAMES.push(jq_iframe);
                        } );



		</script>

	</body>
</html>
